#ifndef __FFT_H__
#define __FFT_H__
/*==================================================================

  FFT library header file
    for fft.c

  Copyright (c) 2004-2005 N099

==================================================================*/
#define FFT_PI 3.1415926535897932384626433832795028841971

/* FFT  Inverse FFT */
#define  FFT  -1
#define IFFT   1

typedef struct tag_Complex 
{
  double r;
  double i;
} Complex;

/*------------------------------------------------------------------
  1D,2D FFT
------------------------------------------------------------------*/
int fft_1D(int num, int s, Complex *);
int fft_2D(int col, int row, int s, Complex **);

/*------------------------------------------------------------------
  1D,2D memory allocation
------------------------------------------------------------------*/
Complex *mallocComplex1D(int num);
Complex **mallocComplex2D(int col, int row);

void freeComplex1D(Complex *);
void freeComplex2D(Complex **);

/*------------------------------------------------------------------
  util
------------------------------------------------------------------*/
int check_2spow(int);

#endif /* #ifndef __FFT_H__ */

