//
// util.c
// 낢Ȋ֐
//
// Copyright (c) 2005  N099
//
#include <windows.h>
#include <math.h>
#include <mmintrin.h>

#include "filter.h"
#include "anti_beat.h"
#include "util.h"
#include "fft.h"

//r[g̈ʑope[u쐬
int make_tbl(FILTER *fp, FILTER_PROC_INFO *fpip, short *tc, short *ts)
{
  short *dst_c, *dst_s;
  int i,j;
  double hf,vf;
  double dh,dv;
  static int h_fine = 0x7fffffff;
  static int h_coarse = 0x7fffffff;
  static int v_fine = 0x7fffffff;
  static int v_coarse = 0x7fffffff;
  static int width = -1;
  static int height = -1;
  
  if(NULL == ts || NULL == tc)
    return 1;
  
  //ݒlꍇ͂̂܂
  if(h_fine == fp->track[T_H_FINE] && h_coarse == fp->track[T_H_COARSE]
     && v_fine == fp->track[T_V_FINE] && v_coarse == fp->track[T_V_COARSE]
     && width == fpip->w && height == fpip->h){
    return 0;
  }
  
  _mm_empty();
  hf = (fp->track[T_H_COARSE] * 256 + fp->track[T_H_FINE])*FFT_PI/(1<<16);
  vf = (fp->track[T_V_COARSE] * 256 + fp->track[T_V_FINE])*FFT_PI/(1<<16);

  
  //ʑpi/2ꂽn
  for(i=0; i<fpip->h; i++){
    dst_c = tc + i*fpip->max_w;
    dst_s = ts + i*fpip->max_w;
    dv = vf * i;
    for(j=0; j<fpip->w; j++){
      dh = hf * j;

      *dst_c = (1<<SH_AMP) * cos(dh + dv) + 0.5;
      *dst_s = (1<<SH_AMP) * sin(dh + dv) + 0.5;
        
      ++dst_c;
      ++dst_s;
    }
    for( ; j<fpip->max_w; j++){
      //͈͊O0ɂĂ
      *dst_c = 0;
      *dst_s = 0;
        
      ++dst_c;
      ++dst_s;
    }
  }

  //ݒlۑ
  h_fine = fp->track[T_H_FINE];
  h_coarse = fp->track[T_H_COARSE];
  v_fine = fp->track[T_V_FINE];
  v_coarse = fp->track[T_V_COARSE];
  width = fpip->w;
  height = fpip->h;

  return 0;
}

//r[g̈ʑope[u\
void disp_beat(FILTER *fp, FILTER_PROC_INFO *fpip, short *tbl)
{
  PIXEL_YC *ycp;
  short *src,*dst,si;
  int i,j;

  if(NULL == tbl)
    return;

  //e[uf[^Rs[
  for(i=0; i<fpip->h; i++){
    ycp = fpip->ycp_edit + i*fpip->max_w;
    src = tbl + i*fpip->max_w;
    for(j=0; j<fpip->w; j++){
      dst = (short*)ycp;
      dst += fp->track[T_CH];

      if(0 == fp->track[T_CH]) //Px
        si = *src + 2048;
      else //F
        si = *src;

      //2g\Ƃ͐U߂
      if(fp->check[C_2DFREQ]) si >>= 5;
      else si >>= 2;

      *dst += si;
      
      ++ycp;
      ++src;
    }
  }
}

//2DFFTsĕ\
void disp_2dfreq(FILTER *fp, FILTER_PROC_INFO *fpip)
{
  PIXEL_YC *ycp;
  Complex **c;
  const int col = check_2spow(fpip->h);
  const int row = check_2spow(fpip->w);
  int i,j,l,m;
  short *psi,si;
  double a,b,gain;
    
  _mm_empty();
    
  c = mallocComplex2D(col, row);
  if(NULL == c){
    return;
  }

  //FFTpɃf[^ϊ
  for(i=0; i<fpip->h; i++){
    ycp = fpip->ycp_edit + i*fpip->max_w;
    for(j=0; j<fpip->w; j++){
      psi = (short*)ycp;
      psi += fp->track[T_CH];

      c[i][j].r = *psi;
        
      ++ycp;
    }
  }

  //2FFT
  fft_2D(col, row, FFT, c);

  //ʂ摜ɕϊ
  gain = (4 << fp->track[T_FFT_GAIN])/(double)(col*row);
  for(i=0; i<fpip->h; i++){
    ycp = fpip->ycp_edit + i*fpip->max_w;
    if((fp->track[T_FFT_QUAD] >> 1)^(fp->track[T_FFT_QUAD] & 1)){
      l = i ? col-i : i;
    }else{
      l = i;
    }
    
    for(j=0; j<fpip->w; j++){
      if(i!=col/2 && j!=row/2){       
        if(fp->track[T_FFT_QUAD] >= 2){
          m = j ? row-j : j;
        }else{
          m = j;
        }
        a = sqrt(c[l][m].r*c[l][m].r + c[l][m].i*c[l][m].i);
        if(fp->check[C_PHASE]){
          b = 1024.0/a;
          ycp->cr = b * c[l][m].r;
          ycp->cb = b * c[l][m].i;
        }else{
          ycp->cr = ycp->cb = 0;
        }
        
        a *= gain;
        if(a>4095.0) a = 4095.0;
        si = a;
        
        ycp->y = si;
      }else{
        //E\
        ycp->y = 4095;
        ycp->cr = ycp->cb = 0;
      }
      ++ycp;
    }
  }
  freeComplex2D(c);
}

//摜̓̃`lpbN/ApbN
void unpack_data(short *dst, const PIXEL_YC *src, FILTER_PROC_INFO *fpip, int ch)
{
  short *ssrc, *sdst;
  const int h = fpip->h;
  const int w = fpip->w;
  const int max_w = fpip->max_w;
  int i,j;

  for(i=0; i<h; ++i){
    ssrc = (short*)(src + i * max_w);
    sdst = dst + i * max_w;
    ssrc += ch;

    for(j=0; j<w; ++j){
      *sdst = *ssrc;
      ++sdst;
      ssrc += 3;
    }
  }
}

void pack_data(PIXEL_YC *dst, const short *src, FILTER_PROC_INFO *fpip, int ch)
{
  const short *ssrc;
  short *sdst;
  const int h = fpip->h;
  const int w = fpip->w;
  const int max_w = fpip->max_w;
  int i,j;

  for(i=0; i<h; ++i){
    ssrc = src + i * max_w;
    sdst = (short*)(dst + i * max_w);
    sdst += ch;
    for(j=0; j<w; ++j){
      *sdst = *ssrc;
      ++ssrc;
      sdst += 3;
    }
  }
}

//Ŝɓver
//ςvZāAʑEUo
CS_PROD prod_beat_a(short *img, const short *c, const short *s,
                    FILTER_PROC_INFO *fpip)
{
  CS_PROD cspd;
  int i,j,itmp;
  const int h = fpip->h;
  int w = fpip->w;
  const int max_w = fpip->max_w;
  long long pds,pdc;
  __m64 *img0, *c0, *s0;
  __m64 mi, ms, mc, sums, sumc;

  pds = pdc = 0;
  
  //wȏAmax_w4̔{Ƃ
  //max_w8̔{ł̂͊miԂj
  w += w&3 ? (4-(w&3)) : 0;
  if(w>max_w){
    //ɂ邱Ƃ͂Ȃ͂
    cspd.c = 0;
    cspd.s = 0;
    return cspd;
  }

  //4fPʂŏ
  w /= 4;
  for(i=0; i<h; ++i){
    img0 = (__m64 *)(img + i * max_w);
    c0 = (__m64 *)(c + i * max_w);
    s0 = (__m64 *)(s + i * max_w);

    sumc = _mm_setzero_si64();
    sums = _mm_setzero_si64();
    for(j=0; j<w; ++j){
      mi = *img0;
      mc = _mm_madd_pi16(*c0, mi);
      ms = _mm_madd_pi16(*s0, mi);
      sumc = _mm_add_pi32(sumc, mc);
      sums = _mm_add_pi32(sums, ms);
      
      ++img0;
      ++c0;
      ++s0;
    }
    //v
    itmp = _mm_cvtsi64_si32(sumc);
    pdc += itmp;
    sumc = _mm_srli_si64(sumc, 32);
    itmp = _mm_cvtsi64_si32(sumc);
    pdc += itmp;
    
    itmp = _mm_cvtsi64_si32(sums);
    pds += itmp;
    sums = _mm_srli_si64(sums, 32);
    itmp = _mm_cvtsi64_si32(sums);
    pds += itmp;
  }
  
  _mm_empty();

  //K
  pds /= h * w * 2;
  pds >>= SH_AMP;
  pdc /= h * w * 2;
  pdc >>= SH_AMP;
  
  cspd.c = pdc;
  cspd.s = pds;

  return cspd;
}

//r[gZ
void sub_beat_a(short *img, const short *c, const short *s,
                FILTER_PROC_INFO *fpip, CS_PROD *pcsp)
{
  int i,j;
  const int h = fpip->h;
  int w = fpip->w;
  const int max_w = fpip->max_w;
  __m64 *img0, *c0, *s0;
  __m64 mt, ms, mc, mcoef;

  //wȏAmax_w4̔{Ƃ
  //max_w8̔{ł̂͊miԂj
  w += w&3 ? (4-(w&3)) : 0;
  if(w>max_w){
    //ɂ邱Ƃ͂Ȃ͂
    return;
  }

  //WZbg
  mcoef = _mm_set_pi16(- pcsp->s, - pcsp->c, - pcsp->s, - pcsp->c);
  
  //4fPʂŏ
  w /= 4;
  for(i=0; i<h; ++i){
    img0 = (__m64 *)(img + i * max_w);
    c0 = (__m64 *)(c + i * max_w);
    s0 = (__m64 *)(s + i * max_w);

    for(j=0; j<w; ++j){
      mt = mc = *c0;
      ms = *s0;

      mc = _mm_unpackhi_pi16(mc, ms);
      mt = _mm_unpacklo_pi16(mt, ms);
        
      mc = _mm_madd_pi16(mc, mcoef);
      mt = _mm_madd_pi16(mt, mcoef);
      mc = _mm_srai_pi32(mc, SH_AMP);
      mt = _mm_srai_pi32(mt, SH_AMP);
      
      mt = _mm_packs_pi32(mt, mc);

      *img0 = _mm_adds_pi16(*img0, mt);
      
      ++img0;
      ++c0;
      ++s0;
    }
  }
  
  _mm_empty();
  
}

//r[g̕zɉver
//ςvZāAʑEUo
CS_PROD prod_beat_b(short *img, const short *c, const short *s,
                    FILTER_PROC_INFO *fpip)
{
  CS_PROD cspd;
  int i,j,itmp;
  const int h = fpip->h;
  int w = fpip->w;
  const int max_w = fpip->max_w;
  long long pds,pdc;
  __m64 *img0, *c0, *s0, *c1, *s1;
  __m64 mi, ms, mc, sums, sumc;

  pds = pdc = 0;
  
  //wȏAmax_w4̔{Ƃ
  //max_w8̔{ł̂͊miԂj
  w += w&3 ? (4-(w&3)) : 0;
  if(w>max_w){
    //ɂ邱Ƃ͂Ȃ͂
    cspd.c = 0;
    cspd.s = 0;
    return cspd;
  }

  //4fPʂŏ
  w /= 4;
  for(i=0; i<h; ++i){
    img0 = (__m64 *)(img + i * max_w);
    c1 = img0 + h * max_w / 4; // ŁAh * max_w ͉摜TCYŁÄ16bit/pixel
    s1 = img0 + h * max_w / 2; // 64bitZ1v[̃ItZbg (h * max_w)/4
    c0 = (__m64 *)(c + i * max_w);
    s0 = (__m64 *)(s + i * max_w);

    //img0,c1,s1̊֌Wiς̊i[ʒu͏c1,s1̃RgQƁj
    //img = fpip->ycp_temp z肵ĂāA3ėp
    // img0 -> ApbN摜f[^i1/3ɂȂĂj
    // c1 -> cimg̓(16bit)א2pixelŉZAintŊi[
    // s1 -> sij
    
    sumc = _mm_setzero_si64();
    sums = _mm_setzero_si64();
    for(j=0; j<w; ++j){
      mi = *img0;
      mc = _mm_madd_pi16(*c0, mi);
      ms = _mm_madd_pi16(*s0, mi);
      sumc = _mm_add_pi32(sumc, mc);
      sums = _mm_add_pi32(sums, ms);
      //ςLĂ
      *c1 = mc;
      *s1 = ms;
      
      ++img0;
      ++c1;
      ++s1;
      ++c0;
      ++s0;
    }
    //v
    itmp = _mm_cvtsi64_si32(sumc);
    pdc += itmp;
    sumc = _mm_srli_si64(sumc, 32);
    itmp = _mm_cvtsi64_si32(sumc);
    pdc += itmp;
    
    itmp = _mm_cvtsi64_si32(sums);
    pds += itmp;
    sums = _mm_srli_si64(sums, 32);
    itmp = _mm_cvtsi64_si32(sums);
    pds += itmp;
  }
  
  _mm_empty();

  //K
  pds /= h * w * 2;
  pds >>= SH_AMP;
  pdc /= h * w * 2;
  pdc >>= SH_AMP;
  
  cspd.c = pdc;
  cspd.s = pds;

  return cspd;
}

//r[gZ
void sub_beat_b(short *img, const short *c, const short *s,
                FILTER_PROC_INFO *fpip)
{
  int i,j;
  const int h = fpip->h;
  int w = fpip->w;
  const int max_w = fpip->max_w;
  __m64 *img0, *c0, *s0, *cof0;
  __m64 mt, ms, mc;

  //wȏAmax_w4̔{Ƃ
  //max_w8̔{ł̂͊miԂj
  w += w&3 ? (4-(w&3)) : 0;
  if(w>max_w){
    //ɂ邱Ƃ͂Ȃ͂
    return;
  }
  
  //4fPʂŏ
  w /= 4;
  for(i=0; i<h; ++i){
    img0 = (__m64 *)(img + i * max_w);
    //Wimg2Ԗڂ̃v[Ɋi[AXgCh2{
    cof0 = (__m64 *)(img + (2*i+h) * max_w);
    c0 = (__m64 *)(c + i * max_w);
    s0 = (__m64 *)(s + i * max_w);

    for(j=0; j<w; ++j){
      //Zp̃r[g
      mt = mc = *c0;
      ms = *s0;
      //*c0(c3, c2, c1, c0)
      //*s0(s3, s2, s1, s0)
      
      //sin,cospbN
      mc = _mm_unpackhi_pi16(mc, ms); //mc(s3, c3, s2, c2)
      mt = _mm_unpacklo_pi16(mt, ms); //mt(s1, c1, s0, c0)

      //WǂݏoĊ|킹
      //*cof0    (sc1, cc1, sc0, cc0)
      //*(cof0+1)(sc3, cc3, sc2, cc2)
      mt = _mm_madd_pi16(mt, *cof0); //mt(sc1*s1+cc1*c1, sc0*s0+cc0*c0)
      mt = _mm_srai_pi32(mt, SH_AMP);
      ++cof0;
      
      mc = _mm_madd_pi16(mc, *cof0); //mc(sc3*s3+cc3*c3, sc2*s2+cc2*c2)
      mc = _mm_srai_pi32(mc, SH_AMP);

      //(32bit*2)*2 -> 16bit*4ɃpbN
      mt = _mm_packs_pi32(mt, mc);
      //mt(sc3*s3+cc3*c3, sc2*s2+cc2*c2, sc1*s1+cc1*c1, sc0*s0+cc0*c0) >> SH_AMP

      //r[gZ
      *img0 = _mm_subs_pi16(*img0, mt);
      
      ++img0;
      ++c0;
      ++s0;
      ++cof0;
    }
  }
  
  _mm_empty();
  
}

//̃ubNPʂňʑƐUo
void detect_beat(short *img, short *ptmp,
                 FILTER *fp, FILTER_PROC_INFO *fpip, CS_PROD *pcsp)
{
  int i,j,l,m;
  int x,x2,xx,y,y2;
  long sum_sq;
  long sum_c = 0;
  long sum_s = 0;
  short *pt;
  int *pc,*ps;
  const int h = fpip->h;
  const int w = fpip->w;
  const int max_w = fpip->max_w;
  const int csp2 = pcsp->c * pcsp->c + pcsp->s * pcsp->s;
  
  //ݒ肪0̏ꍇW[ɂĂ܂
  if(0 == (fp->track[T_H_COARSE] * 256 + fp->track[T_H_FINE]) ||
     0 == (fp->track[T_V_COARSE] * 256 + fp->track[T_V_FINE])){
    memset(img + h * max_w, 0, 2 * h * max_w * sizeof(short));
    return;
  }

  //̃sNZ
  x = (1<<17)/(fp->track[T_H_COARSE] * 256 + fp->track[T_H_FINE]);
  y = (1<<17)/(fp->track[T_V_COARSE] * 256 + fp->track[T_V_FINE]);

  //x2:̉̃sNZTCY x:x2̔
  x = (abs(x) / 2); //͔ɂȂĂ(:int pixel:short)
  if(x<2) x = 2;
  xx = x + (x&1); //xx2̔{i2sNZ̍vintɊi[Ă邽߁j
  x2 = x*2;
  //y2:̏c̃sNZTCY y:y2̔
  y2 = abs(y);
  if(y2<2) y2 = 2;
  y  = y2/2;

  for(i=0; i+y2<h; i+=y){
    for(j=0; j+x2<w; j+=xx){ // j  pixel Pʂ2̔{
      sum_c = 0;
      sum_s = 0;
      //c~̃ubN̓ς̑avZ
      //c:y2 pixel  :xint
      for(l=0; l<y2; ++l){
        pc = (int *)(img + j + (i+h+l) * max_w);
        ps = (int *)(img + j + (i+2*h+l) * max_w);
        for(m=0; m<x; ++m){
          sum_c += *pc;
          sum_s += *ps;
          ++ps;
          ++pc;
        }
      }
      
      //K
      sum_s /= x * y2;
      sum_s >>= SH_AMP;
      sum_c /= x * y2;
      sum_c >>= SH_AMP;

      //S̕ςƂɃNbv
      sum_sq = sum_s * sum_s + sum_c * sum_c;
      if(sum_sq > csp2*2){
        sum_s = pcsp->s;
        sum_c = pcsp->c;
      }else if(sum_sq < csp2/2){
        sum_s = 0;
        sum_c = 0;
      }

      //WpbN`ŕۑ
      //c~̃ubN̍㕔ɕۑi4یj
      for(l=0; l<y; ++l){
        //ʊi[ɂ32bit/pixelp̂2{Ă
        pt = ptmp + 2*(j + (i+l) * max_w);
        for(m=0; m<xx; ++m){
          //1[v1pixel
          *pt = sum_c;
          ++pt;
          *pt = sum_s;
          ++pt;
        }
      }
    } // for(j=0; j+x2<w; j+=xx){ // j  pixel P

    //E[̏F̃ubŇʂŖ߂
    if(j-xx > 0){
      for(l=0; l<y; ++l){
        //ʊi[ɂ32bit/pixelp̂2{Ă
        pt = ptmp + 2*(j + (i+l) * max_w);
        for(m=j; m<w; ++m){
          //sum_c,sum_sɂ͍ubŇʂcĂ̂ł̂܂܎g
          *pt = sum_c;
          ++pt;
          *pt = sum_s;
          ++pt;
        }
        //E1/4XCh
        pt = ptmp + 2*(i+l) * max_w;
        memmove(pt+xx, pt, (w-xx/2)*sizeof(int)); //xx2̔{Ȃ̂32bitPʂɂȂ
      }
      
    }else{
      //摜TCYubNɑ΂ďꍇ͏Ȃ
      memset(img + h * max_w, 0, 2 * h * max_w * sizeof(short));
      return;
    }
    
  }
  
  //ꎞ̈悩珑߂iWimg2Ԗڂ̃v[Ɋi[j
  if(i-y > 0){
    y2 = y/2; //y211/4
    //[̏F̃ubŇʂŖ߂
    for(j=i ; j<h; ++j){
      memcpy(ptmp + 2*j * max_w, ptmp + 2*(i-1) * max_w, max_w*sizeof(int));
    }
    //[͂̂܂܃Rs[
    for(j=0; j<y2; ++j){
      memcpy(img + (h+j*2) * max_w, ptmp + 2*j * max_w, max_w*sizeof(int));
    }
    //1/4XCh
    for( ; j<h; ++j){
      memcpy(img + (h+j*2) * max_w, ptmp + 2*(j-y2) * max_w, max_w*sizeof(int));
    }
  }else{
    //摜TCYubNɑ΂ďꍇ͏Ȃ
    memset(img + h * max_w, 0, 2 * h * max_w * sizeof(short));
    return;
  }

}

